require 'import'
import 'android.widget.Button'
import 'android.widget.LinearLayout'
import 'android.widget.TextView'
import 'android.widget.EditText'
import 'android.app.Activity'
import 'android.view.View'
import 'android.text.InputType'

-- JSON modülü
function parseJSON(str)
    local function trim(s) return s:match("^%s*(.-)%s*$") end
    local success, parsed = pcall(function()
        local data = load("return " .. str:gsub('("[^"]*"):', '[%1]='):gsub('("[^"]*")%s*:', '[%1] = '))()
        return data or {}
    end)
    if success then return parsed else print("JSON parse hatası: " .. tostring(parsed)) return {} end
end

function writeJSON(data, filePath)
    local file = io.open(filePath, "w")
    if not file then print("JSON yazma hatası: Dosya açılamadı: " .. filePath) return false end
    local function serialize(tbl, indent)
        indent = indent or 0
        local str = string.rep(" ", indent) .. "{\n"
        local first = true
        for k, v in pairs(tbl) do
            if not first then str = str .. ",\n" end
            first = false
            str = str .. string.rep(" ", indent + 2) .. '"' .. k .. '": '
            if type(v) == "table" then
                if k == "leaderboard" or k == "words" then
                    if k == "leaderboard" then
                        str = str .. "[\n"
                        local firstEntry = true
                        for _, entry in ipairs(v) do
                            if not firstEntry then str = str .. ",\n" end
                            firstEntry = false
                            str = str .. string.rep(" ", indent + 4) .. "{"
                            str = str .. '"name": "' .. entry.name .. '", '
                            str = str .. '"score": ' .. entry.score .. ', '
                            str = str .. '"games": ' .. entry.games .. "}"
                        end
                        str = str .. "\n" .. string.rep(" ", indent + 2) .. "]"
                    else
                        str = str .. "{\n"
                        local firstCat = true
                        for cat, words in pairs(v) do
                            if not firstCat then str = str .. ",\n" end
                            firstCat = false
                            str = str .. string.rep(" ", indent + 4) .. '"' .. cat .. '": ['
                            local firstWord = true
                            for _, word in ipairs(words) do
                                if not firstWord then str = str .. ", " end
                                firstWord = false
                                str = str .. '"' .. word .. '"'
                            end
                            str = str .. "]"
                        end
                        str = str .. "\n" .. string.rep(" ", indent + 2) .. "}"
                    end
                else
                    str = str .. serialize(v, indent + 2)
                end
            elseif type(v) == "string" then
                str = str .. '"' .. v .. '"'
            else
                str = str .. tostring(v)
            end
        end
        str = str .. "\n" .. string.rep(" ", indent) .. "}"
        return str
    end
    file:write(serialize(data))
    file:close()
    return true
end

-- JSON dosyasını oku
local jsonPath = "/storage/emulated/0/解说/Araçlar/isimsehir/data.json"
local defaultData = {
    words = {
        isim = {
            "Ali", "Ayşe", "Ahmet", "Buse", "Berk", "Can", "Cem", "Çiğdem", "Deniz", "Derya",
            "Ece", "Emre", "Elif", "Eren", "Fatma", "Fatih", "Gamze", "Gökhan", "Hakan", "Hande",
            "Işıl", "İsmail", "İpek", "Kaan", "Kerem", "Lale", "Mert", "Merve", "Murat", "Naber",
            "Nazlı", "Okan", "Onur", "Özge", "Özgür", "Pınar", "Rıza", "Seda", "Selim", "Sema",
            "Şebnem", "Şükrü", "Tamer", "Tuba", "Uğur", "Ümit", "Veli", "Yasemin", "Yusuf", "Zeynep"
        },
        sehir = {
            -- Türkçe şehirler (81 il + bazı ilçeler)
            "Adana", "Adıyaman", "Afyonkarahisar", "Ağrı", "Aksaray", "Amasya", "Ankara", "Antalya", "Ardahan", "Artvin",
            "Aydın", "Balıkesir", "Bartın", "Batman", "Bayburt", "Bilecik", "Bingöl", "Bitlis", "Bolu", "Burdur",
            "Bursa", "Çanakkale", "Çankırı", "Çorum", "Denizli", "Diyarbakır", "Düzce", "Edirne", "Elazığ", "Erzincan",
            "Erzurum", "Eskişehir", "Gaziantep", "Giresun", "Gümüşhane", "Hakkari", "Hatay", "Iğdır", "Isparta", "İstanbul",
            "İzmir", "Kahramanmaraş", "Karabük", "Karaman", "Kars", "Kastamonu", "Kayseri", "Kırıkkale", "Kırklareli", "Kırşehir",
            "Kilis", "Kocaeli", "Konya", "Kütahya", "Malatya", "Manisa", "Mardin", "Mersin", "Muğla", "Muş",
            "Nevşehir", "Niğde", "Ordu", "Osmaniye", "Rize", "Sakarya", "Samsun", "Siirt", "Sinop", "Sivas",
            "Şanlıurfa", "Şırnak", "Tekirdağ", "Tokat", "Trabzon", "Tunceli", "Uşak", "Van", "Yalova", "Yozgat",
            "Zonguldak",
            -- Türkçe ilçeler (örnek)
            "Alanya", "Avcılar", "Beyoğlu", "Bodrum", "Çeşme", "Datça", "Ereğli", "Fethiye", "Gebze", "Hopa",
            -- Yabancı şehirler
            "Amsterdam", "Athens", "Atlanta", "Auckland", "Bangkok", "Barcelona", "Beijing", "Berlin", "Bogota", "Boston",
            "Brisbane", "Brussels", "Budapest", "Buenos Aires", "Cairo", "Cape Town", "Chicago", "Copenhagen", "Dallas", "Delhi",
            "Dubai", "Dublin", "Edinburgh", "Florence", "Frankfurt", "Geneva", "Hamburg", "Hanoi", "Helsinki", "Hong Kong",
            "Houston", "Jakarta", "Jerusalem", "Johannesburg", "Kiev", "Kuala Lumpur", "Lagos", "Lisbon", "London", "Los Angeles",
            "Madrid", "Manila", "Melbourne", "Mexico City", "Miami", "Milan", "Montreal", "Moscow", "Mumbai", "Munich",
            "Nairobi", "New York", "Oslo", "Paris", "Prague", "Rio de Janeiro", "Rome", "San Francisco", "Sao Paulo", "Seoul",
            "Shanghai", "Singapore", "Stockholm", "Sydney", "Taipei", "Tokyo", "Toronto", "Vancouver", "Vienna", "Warsaw",
            "Washington", "Zurich"
        },
        hayvan = {
            "Aslan", "Ayı", "Balıky", "Böcek", "Ceylan", "Çita", "Deve", "At", "Bizon", "Cırcır Böceği",
            "Domuz", "Eşek", "Fıstık Kurdu", "Fil", "Geyik", "Hindi", "İguana", "Jaguar", "Kanguru", "Kaplan",
            "Karga", "Kedi", "Köpek", "Kurt", "Kutuplu Ayı", "Lemur", "Maymun", "Panda", "Penguen", "Piton",
            "Sincap", "Şahin", "Timsah", "Yılan", "Zebra", "Zürafa", "Ördek", "Örümcek", "Tavşan", "Tilki",
            "Uğur Böceği", "Vatoz", "Yunus", "Yengeç"
        },
        bitki = {
            "Armut", "Ayçiçeği", "Biber", "Buğday", "Çam", "Çiçek", "Domates", "Adaçayı", "Bambu", "Ceviz",
            "Çilek", "Defne", "Elma", "Fesleğen", "Gül", "Havuç", "Ispanak", "İncir", "Kaktüs", "Kavun",
            "Kekik", "Lahana", "Lale", "Mantar", "Mısır", "Naber", "Naber", "Patates", "Pırasa", "Portakal",
            "Roka", "Salatalık", "Sarmaşık", "Soğan", "Şeftali", "Üzüm", "Yaban Mersini", "Zambak"
        },
        esya = {
            "Araba", "Ayna", "Bıçak", "Bardak", "Cüzdan", "Çanta", "Defter", "Ampul", "Bilgisayar", "Cep Telefonu",
            "Çekiç", "Dolap", "Eldiven", "Fırça", "Gözlük", "Halı", "İp", "Kamera", "Koltuk", "Lamba",
            "Masa", "Makas", "Pano", "Perde", "Radyo", "Sandalye", "Şemsiye", "Tabak", "Televizyon", "Uçak",
            "Vazo", "Yastık", "Zarf"
        }
    },
    leaderboard = {
        {name = "Oyuncu", score = 0, games = 0},
        {name = "Bot", score = 0, games = 0}
    }
}
local file = io.open(jsonPath, "r")
local data = file and parseJSON(file:read("*a")) or defaultData
if file then file:close() else print("JSON dosyası bulunamadı, varsayılan veri kullanılıyor.") end
if not data.words then data.words = defaultData.words end
if not data.leaderboard then data.leaderboard = defaultData.leaderboard end
-- Lider tablosunda Oyuncu ve Bot girişlerini garantile
for _, player in ipairs({{name = "Oyuncu"}, {name = "Bot"}}) do
    local found = false
    for _, entry in ipairs(data.leaderboard) do
        if entry.name == player.name then found = true break end
    end
    if not found then table.insert(data.leaderboard, {name = player.name, score = 0, games = 0}) end
end

-- Oyun durumu
local gameState = {
    players = {{name = "Oyuncu", score = 0, words = {}}, {name = "Bot", score = 0, words = {}}},
    currentPlayer = 1,
    currentLetter = nil,
    round = 1,
    maxRounds = 5,
    gameOver = false,
    gameStarted = false,
    botLevel = nil,
    timeLimit = nil,
    selectingTimeLimit = false,
    gameResult = "",
    startTime = nil,
    remainingTime = 0,
    editTexts = {},
    roundHistory = {}
}

-- Kategori isimleri
local categoryDisplayNames = {isim = "İsim", sehir = "Şehir", hayvan = "Hayvan", bitki = "Bitki", esya = "Eşya"}

-- Rastgele harf
local letters = {"A", "B", "C", "Ç", "D", "E", "F", "G", "H", "I", "İ", "J", "K", "L", "M", "N", "O", "Ö", "P", "R", "S", "Ş", "T", "U", "Ü", "V", "Y", "Z"}
function getRandomLetter()
    return letters[math.random(1, #letters)]
end

-- Sesli bildirim
function announce(message)
    print(message)
end

-- Kelime kontrolü
function checkWord(word, category, letter)
    if word == "" then return false end
    if string.sub(word, 1, 1):upper() ~= letter then return false end
    for _, validWord in ipairs(data.words[category] or {}) do
        if validWord:upper() == word:upper() then return true end
    end
    return false
end

-- Puanlama
function calculateScore(playerWords, opponentWords, letter)
    local score = 0
    for category, word in pairs(playerWords) do
        if checkWord(word, category, letter) then
            score = score + (opponentWords[category] and opponentWords[category]:upper() == word:upper() and 5 or 10)
        end
    end
    return score
end

-- Bot hamlesi
function botMove(letter)
    local words = {}
    for category, _ in pairs(data.words) do
        local validWords = {}
        for _, word in ipairs(data.words[category] or {}) do
            if string.sub(word, 1, 1):upper() == letter then
                table.insert(validWords, word)
            end
        end
        words[category] = (gameState.botLevel == "easy" and math.random() < 0.3) and "" or (#validWords > 0 and validWords[math.random(1, #validWords)] or "")
    end
    return words
end

-- Lider tablosu güncelleme
function updateLeaderboard()
    for _, player in ipairs(gameState.players) do
        for _, entry in ipairs(data.leaderboard) do
            if entry.name == player.name then
                entry.score = entry.score + player.score
                entry.games = entry.games + 1
                break
            end
        end
    end
    table.sort(data.leaderboard, function(a, b) return a.score > b.score end)
    if not writeJSON(data, jsonPath) then announce("Lider tablosu kaydedilemedi!") end
end

-- Turu değerlendir
function evaluateRound()
    for category, _ in pairs(data.words) do
        if not gameState.players[1].words[category] then gameState.players[1].words[category] = "" end
    end
    if gameState.startTime and (os.time() - gameState.startTime) >= gameState.timeLimit then
        announce("Zaman sınırı doldu!")
    end

    local playerWords = gameState.players[1].words
    local botWords = gameState.players[2].words
    local letter = gameState.currentLetter

    local playerScore = calculateScore(playerWords, botWords, letter)
    local botScore = calculateScore(botWords, playerWords, letter)

    gameState.players[1].score = gameState.players[1].score + playerScore
    gameState.players[2].score = gameState.players[2].score + botScore

    table.insert(gameState.roundHistory, {
        round = gameState.round,
        letter = letter,
        playerWords = {isim = playerWords.isim or "", sehir = playerWords.sehir or "", hayvan = playerWords.hayvan or "", bitki = playerWords.bitki or "", esya = playerWords.esya or ""},
        botWords = {isim = botWords.isim or "", sehir = botWords.sehir or "", hayvan = botWords.hayvan or "", bitki = botWords.bitki or "", esya = playerWords.esya or ""},
        playerScore = playerScore,
        botScore = botScore
    })

    local status = "Tur " .. gameState.round .. " bitti! Harf: " .. letter .. "\n"
    status = status .. "Oyuncu: " .. (playerWords.isim or "") .. ", " .. (playerWords.sehir or "") .. ", " .. (playerWords.hayvan or "") .. ", " .. (playerWords.bitki or "") .. ", " .. (playerWords.esya or "") .. " (" .. playerScore .. " puan)\n"
    status = status .. "Bot: " .. (botWords.isim or "") .. ", " .. (botWords.sehir or "") .. ", " .. (botWords.hayvan or "") .. ", " .. (botWords.bitki or "") .. ", " .. (botWords.esya or "") .. " (" .. botScore .. " puan)"
    announce(status)

    if gameState.round >= gameState.maxRounds then
        gameState.gameOver = true
        updateLeaderboard()
        if gameState.players[1].score > gameState.players[2].score then
            gameState.gameResult = "Kazanan: Oyuncu"
            announce("Tebrikler dostum, kazandın!")
        elseif gameState.players[2].score > gameState.players[1].score then
            gameState.gameResult = "Kazanan: Bot"
            announce("Maalesef bot kazandı.")
        else
            gameState.gameResult = "Berabere"
            announce("Berabere!")
        end
    else
        gameState.round = gameState.round + 1
        gameState.currentLetter = getRandomLetter()
        gameState.players[1].words = {}
        gameState.players[2].words = {}
        gameState.currentPlayer = 1
        gameState.startTime = os.time()
        gameState.remainingTime = gameState.timeLimit
        for _, editText in pairs(gameState.editTexts) do editText.Text = "" end
        announce("Yeni tur başladı! Harf: " .. gameState.currentLetter .. ", Süre: " .. gameState.timeLimit .. " saniye")
    end
    updateLayout()
end

-- Oyunu sıfırla
function resetGame()
    gameState = {
        players = {{name = "Oyuncu", score = 0, words = {}}, {name = "Bot", score = 0, words = {}}},
        currentPlayer = 1,
        currentLetter = nil,
        round = 1,
        maxRounds = 5,
        gameOver = false,
        gameStarted = false,
        botLevel = nil,
        timeLimit = nil,
        selectingTimeLimit = false,
        gameResult = "",
        startTime = nil,
        remainingTime = 0,
        editTexts = {},
        roundHistory = {}
    }
    updateLayout()
    announce("Oyun sıfırlandı! Zorluk seviyesini ve zaman sınırını seçin.")
end

-- Layout oluşturma
layout = LinearLayout(this)
layout.setOrientation(1)

function updateLayout()
    layout.removeAllViews()

    -- EditText’ler (3+2)
    if gameState.gameStarted and not gameState.gameOver and gameState.currentPlayer == 1 then
        local layoutKategoriler1 = LinearLayout(this)
        layoutKategoriler1.setOrientation(0)
        local layoutKategoriler2 = LinearLayout(this)
        layoutKategoriler2.setOrientation(0)
        local categories = {"isim", "sehir", "hayvan", "bitki", "esya"}
        for i, category in ipairs(categories) do
            local displayName = categoryDisplayNames[category]
            local editText = EditText(this)
            editText.setHint(displayName .. " (Harf: " .. gameState.currentLetter .. ")")
            editText.setContentDescription(displayName .. " için kelime girin, harf: " .. gameState.currentLetter)
            editText.setInputType(InputType.TYPE_CLASS_TEXT | InputType.TYPE_TEXT_FLAG_NO_SUGGESTIONS)
            editText.setFocusable(true)
            editText.setFocusableInTouchMode(true)
            editText.requestFocus()
            editText.setVisibility(View.VISIBLE)
            gameState.editTexts[category] = editText
            if i <= 3 then layoutKategoriler1.addView(editText) else layoutKategoriler2.addView(editText) end
        end
        layout.addView(layoutKategoriler1)
        layout.addView(layoutKategoriler2)
    end

    -- Oyun durumu
    local textStatus = TextView(this)
    local status = "Tur: " .. gameState.round .. "/" .. gameState.maxRounds .. "\n"
    status = status .. "Harf: " .. (gameState.currentLetter or "Yok") .. "\n"
    status = status .. "Oyuncu puanı: " .. gameState.players[1].score .. "\n"
    status = status .. "Bot puanı: " .. gameState.players[2].score .. "\n"
    status = status .. "Zaman sınırı: " .. (gameState.timeLimit or "Seçilmedi") .. "\n"
    if #gameState.roundHistory > 0 then
        status = status .. "Tur Sonuçları:\n"
        for _, history in ipairs(gameState.roundHistory) do
            status = status .. "Tur " .. history.round .. " (Harf: " .. history.letter .. "):\n"
            status = status .. "Oyuncu: " .. (history.playerWords.isim or "") .. ", " .. (history.playerWords.sehir or "") .. ", " .. (history.playerWords.hayvan or "") .. ", " .. (history.playerWords.bitki or "") .. ", " .. (history.playerWords.esya or "") .. " (" .. history.playerScore .. " puan)\n"
            status = status .. "Bot: " .. (history.botWords.isim or "") .. ", " .. (history.botWords.sehir or "") .. ", " .. (history.botWords.hayvan or "") .. ", " .. (history.botWords.bitki or "") .. ", " .. (history.botWords.esya or "") .. " (" .. history.botScore .. " puan)\n"
        end
    end
    status = status .. gameState.gameResult
    textStatus.Text = status
    textStatus.setContentDescription(status)
    textStatus.setVisibility(View.VISIBLE)
    layout.addView(textStatus)

    -- Kalan süre TextView
    local textRemainingTime = TextView(this)
    textRemainingTime.Text = ""
    textRemainingTime.setContentDescription("")
    textRemainingTime.setVisibility(View.VISIBLE)
    layout.addView(textRemainingTime)

    -- Zorluk seçimi
    if not gameState.gameStarted then
        local layoutZorluk = LinearLayout(this)
        layoutZorluk.setOrientation(0)
        for _, level in ipairs({{"Kolay", "easy"}, {"Orta", "medium"}, {"Zor", "hard"}}) do
            local button = Button(this)
            button.Text = level[1]
            button.setContentDescription(level[1] .. " seviye")
            button.setVisibility(View.VISIBLE)
            button.onClick = function()
                gameState.botLevel = level[2]
                announce(level[1] .. " seviye seçildi.")
                updateLayout()
            end
            layoutZorluk.addView(button)
        end
        layout.addView(layoutZorluk)

        -- Zaman sınırı seçimi
        local butonZamanSec = Button(this)
        butonZamanSec.Text = "Zaman Sınırı Seç"
        butonZamanSec.setContentDescription("Zaman sınırı seç")
        butonZamanSec.setVisibility(View.VISIBLE)
        butonZamanSec.onClick = function()
            gameState.selectingTimeLimit = true
            updateLayout()
        end
        layout.addView(butonZamanSec)

        if gameState.selectingTimeLimit then
            local layoutZaman1 = LinearLayout(this)
            layoutZaman1.setOrientation(0)
            local layoutZaman2 = LinearLayout(this)
            layoutZaman2.setOrientation(0)
            for i, sec in ipairs({15, 30, 60, 90, 120, 150, 300, 500, 1000}) do
                local button = Button(this)
                button.Text = sec .. "s"
                button.setContentDescription(sec .. " saniye")
                button.setVisibility(View.VISIBLE)
                button.onClick = function()
                    gameState.timeLimit = sec
                    gameState.selectingTimeLimit = false
                    announce(sec .. " saniye seçildi.")
                    updateLayout()
                end
                if i <= 5 then layoutZaman1.addView(button) else layoutZaman2.addView(button) end
            end
            layout.addView(layoutZaman1)
            layout.addView(layoutZaman2)
        end

        -- Başlat butonu
        local butonBaslat = Button(this)
        butonBaslat.Text = "Başlat"
        butonBaslat.setContentDescription("Oyunu başlat")
        butonBaslat.setVisibility(View.VISIBLE)
        butonBaslat.onClick = function()
            if not gameState.botLevel then announce("Lütfen önce bir zorluk seviyesi seçin.") return end
            if not gameState.timeLimit then announce("Lütfen önce bir zaman sınırı seçin.") return end
            gameState.gameStarted = true
            gameState.gameOver = false
            gameState.currentLetter = getRandomLetter()
            gameState.currentPlayer = 1
            gameState.round = 1
            gameState.players[1].score = 0
            gameState.players[2].score = 0
            gameState.players[1].words = {}
            gameState.players[2].words = {}
            gameState.roundHistory = {}
            gameState.startTime = os.time()
            gameState.remainingTime = gameState.timeLimit
            gameState.editTexts = {}
            textRemainingTime.Text = ""
            textRemainingTime.setContentDescription("")
            announce("Oyun başladı! Harf: " .. gameState.currentLetter .. ", Süre: " .. gameState.timeLimit .. " saniye")
            updateLayout()
        end
        layout.addView(butonBaslat)
    end

    -- Kontrol butonları (3+2)
    local layoutKontrol1 = LinearLayout(this)
    layoutKontrol1.setOrientation(0)
    local layoutKontrol2 = LinearLayout(this)
    layoutKontrol2.setOrientation(0)

    local butonKurallar = Button(this)
    butonKurallar.Text = "Kurallar"
    butonKurallar.setContentDescription("Kuralları oku")
    butonKurallar.setVisibility(View.VISIBLE)
    butonKurallar.onClick = function()
        local rules = [[
        İsim Şehir Kuralları:
        1. Oyuncu ve Bot sırayla oynar.
        2. Her turda rastgele bir harf seçilir.
        3. İsim, Şehir, Hayvan, Bitki, Eşya kategorilerinde harfle başlayan kelimeler girilir.
        4. Puanlama: Doğru kelime 10 puan, aynı kelime 5 puan, geçersiz/boş 0 puan.
        5. 5 tur sonunda en yüksek puanlı oyuncu kazanır.
        ]]
        announce(rules)
        updateLayout()
    end
    layoutKontrol1.addView(butonKurallar)

    local butonSkor = Button(this)
    butonSkor.Text = "Skor"
    butonSkor.setContentDescription("Skorları göster")
    butonSkor.setVisibility(View.VISIBLE)
    butonSkor.onClick = function()
        announce("Oyuncu puanı: " .. gameState.players[1].score .. ", Bot puanı: " .. gameState.players[2].score)
        updateLayout()
    end
    layoutKontrol1.addView(butonSkor)

    local butonSifirla = Button(this)
    butonSifirla.Text = "Sıfırla"
    butonSifirla.setContentDescription("Skorları sıfırla")
    butonSifirla.setVisibility(View.VISIBLE)
    butonSifirla.onClick = function()
        gameState.players[1].score = 0
        gameState.players[2].score = 0
        for _, entry in ipairs(data.leaderboard) do
            entry.score = 0
            entry.games = 0
        end
        writeJSON(data, jsonPath)
        announce("Skorlar sıfırlandı.")
        updateLayout()
    end
    layoutKontrol1.addView(butonSifirla)

    local butonLiderTablosu = Button(this)
    butonLiderTablosu.Text = "Lider Tablosu"
    butonLiderTablosu.setContentDescription("Lider tablosunu göster")
    butonLiderTablosu.setVisibility(View.VISIBLE)
    butonLiderTablosu.onClick = function()
        local lb = "Lider Tablosu:\n"
        for i, entry in ipairs(data.leaderboard) do
            lb = lb .. i .. ". " .. entry.name .. ": " .. entry.score .. " puan (" .. entry.games .. " oyun)\n"
        end
        announce(lb)
        updateLayout()
    end
    layoutKontrol2.addView(butonLiderTablosu)

    if gameState.gameStarted and not gameState.gameOver then
        local butonKalanSure = Button(this)
        butonKalanSure.Text = "Kalan Süreyi Göster"
        butonKalanSure.setContentDescription("Kalan süreyi göster")
        butonKalanSure.setVisibility(View.VISIBLE)
        butonKalanSure.onClick = function()
            if gameState.startTime then
                gameState.remainingTime = gameState.timeLimit - (os.time() - gameState.startTime)
                if gameState.remainingTime <= 0 then
                    gameState.remainingTime = 0
                    textRemainingTime.Text = "Kalan süre: 0 saniye"
                    textRemainingTime.setContentDescription("Kalan süre: 0 saniye")
                    announce("Zaman sınırı doldu!")
                    evaluateRound()
                else
                    local remaining = math.max(0, math.ceil(gameState.remainingTime))
                    textRemainingTime.Text = "Kalan süre: " .. remaining .. " saniye"
                    textRemainingTime.setContentDescription("Kalan süre: " .. remaining .. " saniye")
                    announce("Kalan süre: " .. remaining .. " saniye")
                end
            end
        end
        layoutKontrol2.addView(butonKalanSure)
    end
    layout.addView(layoutKontrol1)
    layout.addView(layoutKontrol2)

    -- Tamam butonu
    if gameState.gameStarted and not gameState.gameOver and gameState.currentPlayer == 1 then
        local butonTamam = Button(this)
        butonTamam.Text = "Tamam"
        butonTamam.setContentDescription("Turu tamamla")
        butonTamam.setVisibility(View.VISIBLE)
        butonTamam.onClick = function()
            for category, editText in pairs(gameState.editTexts) do
                gameState.players[1].words[category] = editText.Text and tostring(editText.Text) or ""
                announce(categoryDisplayNames[category] .. " için kelime: " .. gameState.players[1].words[category])
            end
            if gameState.startTime and (os.time() - gameState.startTime) >= gameState.timeLimit then
                announce("Zaman sınırı doldu!")
            end
            gameState.currentPlayer = 2
            gameState.players[2].words = botMove(gameState.currentLetter)
            evaluateRound()
        end
        layout.addView(butonTamam)
    end

    -- Tekrar başlat
    if gameState.gameOver then
        local butonTekrarBaslat = Button(this)
        butonTekrarBaslat.Text = "Tekrar Başlat"
        butonTekrarBaslat.setContentDescription("Oyunu tekrar başlat")
        butonTekrarBaslat.setVisibility(View.VISIBLE)
        butonTekrarBaslat.onClick = function() resetGame() end
        layout.addView(butonTekrarBaslat)
    end

    activity.setContentView(layout)
end

-- Oyun başlatma
math.randomseed(os.time())
resetGame()
announce("İsim Şehir oyunu yüklendi!")